;______________________________________________________
;	Title:		ASMTest2
;	Author:		Brad Normand (bradn2@yahoo.com)
;	Version:	2.00
;	Release Date:	July 9, 2001
;	File Format:	NASM
;	Dependencies:	included in .zip
;	Permissions:	Use and modify freely, provided
;			that you do not claim this to
;			be your own work, or that any
;			modified versions are mine.
;______________________________________________________


; -------------------------- Includes:

%include "bios.h"
%include "dos.h"
%include "misc.h"
%include "cstr.h"


; -------------------------- Code:

segment code
..start:
	;set up segment registers+stack
	push ds
	mov ax,data
	mov ds,ax
	pop word [PSPS]
	mov ax,stack
	mov ss,ax
	mov sp,stacktop

	;deallocate extra memory+calculate
	;original allocated space

	mov es,[PSPS]
	mov ax,[es:0x0002]
	sub ax,[PSPS]
	mov [OA],ax
	mov ah,0x4a
	mov bx,0x0100	;keep 4k
	int 0x21	;free extra memory

	jnc mnu	;if no error, skip error message
	m_BiosSimpleCLS
	mov dx,msgNM
	call DspStr
	mov dx,msgPK
	call DspStr
RdA:	m_DosReadKeyboard
	cmp al,0x00
	je RdA
mnu:	m_BiosSimpleCLS
	mov dx, msgTS1
	call DspStr
mnulp:	m_DosReadKeyboard
	m_BranchIf ah,ne,0,.SkipN	;handle extended keys
	m_DosReadKeyboard
	jmp short mnulp
.SkipN:	m_BranchIf al,e,'1',short KMent
        m_BranchIf al,e,'2',CLent
        m_BranchIf al,e,'3',INent
	m_BranchIf al,e,'4',EXent
	m_BranchIf al,e,'5',PUent
	m_BranchIf al,e,'6',ABent
	m_BranchIf al,e,'7',MUent
	m_BranchIf al,e,'8',GRent
	m_BranchIf al,e,'9',FLent,mnulp


KMent:	m_BiosSimpleCLS		;Keyboard menu
	mov dx,msgKBM
	call DspStr
	mov dx,msgAKR
	call DspStr
	m_DosReadKeyboard
	m_BranchIf al,e,'1',short KAent
        m_BranchIf al,e,'2',RKent
        m_BranchIf al,ne,0,mnu
	m_DosReadKeyboard
        jmp mnu

KAent:	m_BiosSimpleCLS		;key>ascii
	mov dx,msgmnu
	call DspStr
KAloop:	m_DosReadKeyboard
	push ax
	m_DosDisplayCharacter al ;this destroys AL
	mov dl,'='
	int 0x21 ;another m_DosDisplayCharacter
	pop ax
	xor ah,ah ;AL has the character number
	call DspAX
	mov dx,msgcr
	call DspStr
	jmp short KAloop
CLent:	m_BiosSimpleCLS		;clock
	mov dx,msgCL
	call DspStr
LB:	hlt ;saves battery power (should anyway)
	m_DosGetTime
	push dx
	m_BiosSimpleLocate 0x0000
	cmp ch,0x0a
	jge skipH
	m_DosDisplayCharacter '0'
skipH:	push cx
	xor ax,ax
	mov al,ch
	call DspAX
	pop cx
	m_BiosSimpleLocate 0x0003
	cmp cl,0x0a
	jge skipM
	m_DosDisplayCharacter '0'
skipM:	xor ax,ax
	mov al,cl
	call DspAX
	pop cx

	m_BiosSimpleLocate 0x0006
	cmp ch,0x0a
	jge skipS
	m_DosDisplayCharacter '0'
skipS:	push cx
	xor ax,ax
	mov al,ch
	call DspAX
	pop cx

	m_BiosSimpleLocate 0x0009
	cmp cl,0x0a
	jge skipD
	m_DosDisplayCharacter '0'
skipD:	xor ax,ax
	mov al,cl
	call DspAX
KBD:	m_DosCheckKeyboardStatus
	cmp al,0x00
	je jLB
CLRK:	m_DosReadKeyboard
	cmp al,0x00
	je CLRK
	jmp mnu
jLB:	jmp LB



RKent:	m_BiosSimpleCLS		;raw key test
	hlt

	xor ax,ax
	mov es,ax

	mov ax,[es:0x8]	;save old int 02 vector
	mov [OIs],ax	;
	mov ax,[es:0xa]	;
	mov [OIo],ax	;


	mov ax,[es:0x3fc]	;switch int 02 vector to FF vector
	mov [es:0x8],ax		;
	mov ax,[es:0x3fe]	;
	mov [es:0xa],ax		;

	mov [TMP],byte 11
	cld
.dtlp	in al,0x1D
	mov [TMP+1],al
.mnlp	m_BiosSimpleLocate 0x0000
	mov di,StrBuf
	mov cx,12
	mov ax,1
	push ds
	pop es
;	hlt
.inlp	out 0x13,ax
	push cx
	mov cx,4
.dlp	loop .dlp
	pop cx
	shl ax,1
	mov dx,0x13
	insb
	loop .inlp
	mov si,StrBuf
	mov cx,6
.dslp	lodsw
	push cx
	m_DisplayNumberAXh
	mov dx,msgcr
	call DspStr
	pop cx
	loop .dslp
	in al,0x1D
	cmp [TMP+1],al
	je .mnlp
	dec byte [TMP]
	jz .ex
	jmp .dtlp

	;game over, put the vector back, return to the menu
.ex	xor ax,ax
	mov es,ax
	hlt
	mov ax,[OIs]	;
	mov [es:0x8],ax	;restore int 02 vector
	mov ax,[OIo]	;
	mov [es:0xa],ax	;
	jmp KMent


	

INent:	m_BiosSimpleCLS		;info
	mov dx,msgCS
	call DspStr
	mov ax,cs
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgDS
	call DspStr
	mov ax,ds
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgSS
	call DspStr
	mov ax,ss
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgPSP
	call DspStr
	mov ax,[PSPS]
	mov es,ax
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgENV
	call DspStr
	mov ax,[es:0x002c]
	call DspAXh
	mov dx,msgcr
	call DspStr
	mov dx,msgOA
	call DspStr
	mov ax,[OA]
	call DspAXh
	mov dx,msgOA2
	call DspStr
	mov dx,msgPK
	call DspStr
INRK:	m_DosReadKeyboard
	cmp al,0x00
	je INRK
	jmp mnu
EXent:	m_BiosSimpleCLS		;Exit to DOS
	mov dx,msgNI
	call DspStr
	mov dx,msgPK
	call DspStr
	jmp short INRK
	
PUent:	xor bx,bx		;Port Util.
PURF:	m_BiosSimpleCLS
	;draw the screen
	push bx
	m_BiosSimpleLocate 0x0600
	mov dx,msgPU1
	call DspStr
	pop bx
PUSBL:	mov cx,6 ;update 6 lines
PUDL:	mov dh,cl
	dec dh
	xor dl,dl
	push bx
	xor bh,bh
	mov ah,0x02
	int 0x10
	pop bx
	mov ax,bx
	dec ax
	add ax,cx
	push BX
	push CX
	call DspAXh
	m_DosDisplayCharacter '='
	pop CX
	pop BX
	loop PUDL
PUDV:	;display values

	mov cx,6 ;update 6 lines
PUUL:	mov dh,cl
	dec dh
	mov dl,0x05
	push bx
	xor bh,bh
	mov ah,0x02
	int 0x10
	pop bx
	mov dx,bx
	dec dx
	add dx,cx
	push CX
	push BX
	mov cx,[PUDB]
PUDDL:	push cx
	in al,dx
	call DspALh
	pop cx
	loop PUDDL
	pop BX
	pop CX

	loop PUUL
	m_DosCheckKeyboardStatus
	or al,al
	jz PUDV
	m_DosReadKeyboard
	or al,al
	jnz PUNNK
	jmp PUNK
	;should be a number now
PUNNK:	cmp al,'0'
	jne PUNEX ;continue
	jmp mnu
PUNEX:	cmp al,'1'
	jne PUS1
	mov cx,0001
	push bx
	m_BiosSimpleLocate 0x0600
	mov dx,msgPU2
	call DspStr
	m_BiosSimpleLocate 0x0708
	call GetAXh
	pop bx
	or cl,cl
	jnz PUSNA
	jmp short jPURF
PUSNA:	mov bx,ax
	jmp short jPURF
PUS1:	cmp al,'2'
	jne PUDV
PUGWA:	mov cx,0001
	push bx
	m_BiosSimpleLocate 0x0600
	mov dx,msgPU3
	call DspStr
	m_BiosSimpleLocate 0x0708
	call GetAXh
	pop bx
	or cl,cl
	jnz PUGWB
	jmp short jPURF
PUGWB:	mov si,ax
	mov ch,00
	push bx
	mov dx,msgPU4
	call DspStr
	call GetALh
	pop bx
	or cl,cl
	jz PUGWA
	push si
	pop dx
	out dx,al
jPURF:	jmp PURF
	
PUNK:	m_DosReadKeyboard
	m_BranchIf al,e,58,short PUD58
	m_BranchIf al,e,72,short PUD72
	m_BranchIf al,e,80,short PUD80
	m_BranchIf al,e,75,short PUD75
	m_BranchIf al,e,77,short PUD77,short jPUSBL
PUD58:	inc byte [PUDB]
	cmp byte [PUDB],9
	jne jPUSBL
	mov byte [PUDB],0x1
	jmp short jPURF
PUD72:	dec bx
	jmp short jPUSBL
PUD80:	inc bx
	jmp short jPUSBL
PUD75:	sub bx,0x0006
	jmp short jPUSBL
PUD77:	add bx,0x0006
jPUSBL:	jmp PUSBL
PUEX:	jmp mnu

ABent:	m_BiosSimpleCLS		;About
	mov dx,msgTS2
	call DspStr
lpAB:	m_DosReadKeyboard
	cmp al,0x00
	je lpAB ;ignore the null on an extended key
	m_BiosSimpleCLS	
	mov dx,msgTS3
	call DspStr
lpAB2:	m_DosReadKeyboard
	cmp al,0x00
	je lpAB2 ;ignore the null on an extended key
	jmp short PUEX ;jump to menu

MUent:	m_BiosSimpleCLS		;Mem util.
	mov dx,msgNI
	call DspStr
	mov dx,msgPK
	call DspStr
	jmp short lpAB

GRent:	mov ax,0x0004		;Graphics
	int 0x10
	mov dx,0001
lpGR:	mov cx,128
lpGR2:	push cx
	push dx
	dec dx
	dec cx
	mov ax,cx
	mul dx
	test ah,0x04
	jz GRND
	mov al,0x01
	pop dx
	push dx
	dec dx
	call PxlWr
GRND:	pop dx
GRD:	pop cx
	loop lpGR2
	inc dx
	cmp dx,65
	jne lpGR
	jmp lpAB

FLent:	m_BiosSimpleCLS		;Flash
	mov dx,msgFLM
	call DspStr
	m_DosReadKeyboard
	m_BranchIf ah,ne,0,.SkipN	;handle extended keys
	m_DosReadKeyboard
	jmp mnu
.SkipN:	m_BranchIf al,e,'1',FLers,mnu
FLers:	m_BiosSimpleCLS
	mov dx,msgFLE
	call DspStr
	m_DosReadKeyboard
	m_BranchIf ah,ne,0,.SkipN	;handle extended keys
	m_DosReadKeyboard
	jmp short FLent
.SkipN:	m_BranchIf al,ne,'Y',FLent
	m_BiosSimpleCLS
	mov dx,msgFLe
	call DspStr
	hlt		;make sure no interrupt during vector change
	xor ax,ax
	mov ds,ax
	mov ax,[0x3fc]	;switch int 02 vector to FF vector
	mov [0x8],ax	;
	mov ax,[0x3fe]	;
	mov [0xa],ax	;

	mov al,0xa0
	out 0x56,al	;make sure seg 4000 is set to flash
	mov ax,0x4000
	mov ds,ax	;switch segment 4000
	mov si,0xaaa	;first address used
	mov di,0x554	;second address used

	mov [si],byte 0xaa
	mov [di],byte 0x55
	mov [si],byte 0x80
	mov [si],byte 0xaa
	mov [di],byte 0x55
	mov [si],byte 0x10	;start chip erase


.ErLP	hlt		;halt CPU while waiting
	mov al,[si]	;get first byte for comparison
	mov ah,[si]	;get second byte for comparison
	xor al,ah
	and al,0x40	;has bit 6 toggled?
	jz .RBT		;reboot if not (erase complete)
	and ah,0x20	;is bit 5 set?
	jz .ErLP	;keep waiting if no failure
.RBT	jmp word 0xffff:0x0000	;reboot



; -------------------------- Subroutines:

DspAX:	m_DisplayNumberAX
	ret
DspAXh:	m_DisplayNumberAXh
	ret
DspALh:	m_DisplayNumberALh
	ret
GetAXh:	m_GetNumberAXh
	ret
GetALh:	m_GetNumberALh
	ret
DspStr:	pusha
	mov si,dx
	m_FastDisplayString
	popa
	ret
PxlWr:	pusha
	m_BiosPixelWrite
	popa
	ret
PxlRe:	push bx
	m_BiosPixelRead
	pop bx
	ret
FlInit:	


; -------------------------- Data:

segment data
;messages
msgTS1:	db 'Welcome to ASMTest2',0x0d,0x0a
	db 'for CASIO AFX 2.0',0x0d,0x0a
	db '1-Keyboard    2-Clock'
	db '3-Info  4-Exit to DOS'
	db '5-Port Util.  6-About'
	db '7-Mem. Util.   8-Gfx.'
	db '9-Flash',0x0d,0x0a
	db 'MENU-Exit$'
msgKBM:	db 'Keyboard Tests:',0x0d,0x0a
	db '1-ASCII codes',0x0d,0x0a
	db '2-10 second RAW Test',0x0d,0x0a,'$'
msgTS2:	db ' About ASMTest2 by',0x0d,0x0a
	db ' Brad Normand-2001:',0x0d,0x0a
	db 0x0d,0x0a
	db 'Thanx to dscoshpe for'
	db 'some information used'
	db 'in this-Visit CALiPSO'
	db 'at ccp.s5.com!',0x0d,0x0a
msgPK:	db 'Press a key$'
msgTS3:	db 'Note that in the port'
	db 'utility, you can',0x0d,0x0a
	db 'press OPTION to set',0x0d,0x0a
	db 'how many bytes are',0x0d,0x0a
	db 'read from each port.',0x0d,0x0a,'$'
msgNM:	db 'DOS error freeing',0x0d,0x0a
	db 'excess memory.',0x0d,0x0a,'$'
msgCL:	db '--:--:--.--',0x0d,0x0a
PK2X:	db 'Press a key to exit$'
msgmnu: db 'Hit MENU key to exit'
msgcr:	db 0x0d,0x0a,'$'
msgCS:	db ' CS=$'
msgDS:	db ' DS=$'
msgSS:	db ' SS=$'
msgPSP:	db 'PSP=$'
msgENV:	db 'ENV=$'
msgOA:	db 'Originally allocated',0x0d,0x0a,'$'
msgOA2:	db ' paragraphs.',0x0d,0x0a,'$'
msgPU1:	db 'Arrows move, 0=exit',0x0d,0x0a
	db '1=set addr, 2=write$'
msgPU2:	db 'Enter new hex start',0x0d,0x0a
	db 'offset:            $'
msgPU3:	db 'Enter hex write addr',0x0d,0x0a
	db 'offset:            $'
msgPU4:	db ' byte:$'
;msgMU1:	db 'Memory Utility',0x0d,0x0a
;	db 'Current=    :',0x0d,0x0a
;	db 0x0d,0x0a
;	db '1-Set new location',0x0d,0x0a
;	db '2-Read memory',0x0d,0x0a
;	db '3-Memory Search',0x0d,0x0a
;	db '4-Write/copy memory',0x0d,0x0a
;	db '5-Run        6-Exit$'
;msgMU2:	db 'Confirm',0x0d,0x0a
;	db 'JMP FAR     :',0x0d,0x0a
;	db '1=Yes  2=Cancel$'  ;,0x0d,0x0a
	;db 0x0d,0x0a
	;db ' THIS MAY RESULT IN',0x0d,0x0a
	;db '     DATA LOSS!$'
;msgMU3:	db 'Enter hex data to',0x0d,0x0a
;	db 'search for.  Press',0x0d,0x0a
;	db 'left arrow to end',0x0d,0x0a
;	db 'entry.  128 byte max$'
;msgMU4:	db 'Search? 1=Yes  2=No$'
;msgMU5:	db 'Write/copy memory',0x0d,0x0a
;	db 0x0d,0x0a
;	db '1-Enter hex data',0x0d,0x0a
;	db '2-Copy memory',0x0d,0x0a
;	db '3-Test writability',0x0d,0x0a
;	db 'Other-Prev. menu$'
;msgMU6:	db 'Copy from     :'
;	db 'Enter segment:offset',0x0d,0x0a
;	db 'to copy to.  Left',0x0d,0x0a
;	db 'arrow cancels.',0x0d,0x0a,'$'
;msgMU7:	db 'Copy? 1=Yes  2=No$'
;msgSrc:	db 'Searching...',0x0d,0x0a,'$'
;msgNF:	db 'Not found!',0x0d,0x0a,'$'
;msgFD:	db 'Found!',0x0d,0x0a,'$'
;msgMAC:	db 'Memory at current',0x0d,0x0a
;	db 'location is:',0x0d,0x0a,'$'
;msgMWR:	db 'Read/write$'
;msgMRO:	db 'Read only$'
msgNI:	db 'Not implemented yet.',0x0d,0x0a,'$'
msgFLM: db '1-Erase entire Flash',0x0d,0x0a
	db 0x0d,0x0a
msgAKR:	db 'Any other key returns'
	db 'to the prev. menu.$'
msgFLE:	db 'WARNING:',0x0d,0x0a
	db 'ALL DATA ON FLASH',0x0d,0x0a
	db 'WILL BE LOST!',0x0d,0x0a
	db 0x0d,0x0a
	db 'Press Y to confirm,',0x0d,0x0a
	db 'other keys cancel.$'
msgFLe: db '--ERASE IN PROGRESS--'
	db 0x0d,0x0a
	db 'Calc will reboot',0x0d,0x0a
	db 'when complete.',0x0d,0x0a,'$'


;variables
PSPS:	dw 0x0000
OA:	dw 0x0000
MUSeg:	dw 0x0000
MUOff:	dw 0x0000
PUDB:	dw 0x0001
TMP:	dw 0x0000
OIs:	dw 0x0000
OIo:	dw 0x0000
StrBuf:	times 64 dw 0x0000

segment stack stack
	resb 0x200
stacktop:
